/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <compiz-core.h>

#include "kdecompat_options.h"

static int KdecompatOptionsDisplayPrivateIndex;

static CompMetadata kdecompatOptionsMetadata;

static CompPluginVTable *kdecompatPluginVTable = NULL;
CompPluginVTable kdecompatOptionsVTable;

#define KDECOMPAT_OPTIONS_DISPLAY(d) PLUGIN_DISPLAY(d, KdecompatOptions, o)
#define KDECOMPAT_OPTIONS_SCREEN(s) PLUGIN_SCREEN(s, KdecompatOptions, o)

typedef struct _KdecompatOptionsDisplay
{
    int screenPrivateIndex;

} KdecompatOptionsDisplay;

typedef struct _KdecompatOptionsScreen
{
    CompOption opt[KdecompatScreenOptionNum];
    kdecompatScreenOptionChangeNotifyProc notify[KdecompatScreenOptionNum];
} KdecompatOptionsScreen;

Bool kdecompatGetPlasmaThumbnails (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return os->opt[KdecompatScreenOptionPlasmaThumbnails].value.b;
}

CompOption * kdecompatGetPlasmaThumbnailsOption (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return &os->opt[KdecompatScreenOptionPlasmaThumbnails];
}

void kdecompatSetPlasmaThumbnailsNotify (CompScreen *s, kdecompatScreenOptionChangeNotifyProc notify)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    os->notify[KdecompatScreenOptionPlasmaThumbnails] = notify;
}

Bool kdecompatGetPresentWindows (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return os->opt[KdecompatScreenOptionPresentWindows].value.b;
}

CompOption * kdecompatGetPresentWindowsOption (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return &os->opt[KdecompatScreenOptionPresentWindows];
}

void kdecompatSetPresentWindowsNotify (CompScreen *s, kdecompatScreenOptionChangeNotifyProc notify)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    os->notify[KdecompatScreenOptionPresentWindows] = notify;
}

Bool kdecompatGetSlidingPopups (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return os->opt[KdecompatScreenOptionSlidingPopups].value.b;
}

CompOption * kdecompatGetSlidingPopupsOption (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return &os->opt[KdecompatScreenOptionSlidingPopups];
}

void kdecompatSetSlidingPopupsNotify (CompScreen *s, kdecompatScreenOptionChangeNotifyProc notify)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    os->notify[KdecompatScreenOptionSlidingPopups] = notify;
}

int kdecompatGetSlideInDuration (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return os->opt[KdecompatScreenOptionSlideInDuration].value.i;
}

CompOption * kdecompatGetSlideInDurationOption (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return &os->opt[KdecompatScreenOptionSlideInDuration];
}

void kdecompatSetSlideInDurationNotify (CompScreen *s, kdecompatScreenOptionChangeNotifyProc notify)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    os->notify[KdecompatScreenOptionSlideInDuration] = notify;
}

int kdecompatGetSlideOutDuration (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return os->opt[KdecompatScreenOptionSlideOutDuration].value.i;
}

CompOption * kdecompatGetSlideOutDurationOption (CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return &os->opt[KdecompatScreenOptionSlideOutDuration];
}

void kdecompatSetSlideOutDurationNotify (CompScreen *s, kdecompatScreenOptionChangeNotifyProc notify)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    os->notify[KdecompatScreenOptionSlideOutDuration] = notify;
}

CompOption * kdecompatGetScreenOption (CompScreen *s, KdecompatScreenOptions num)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    return &os->opt[num];
}

static const CompMetadataOptionInfo kdecompatOptionsScreenOptionInfo[] = {
    { "plasma_thumbnails", "bool", 0, 0, 0 },
    { "present_windows", "bool", 0, 0, 0 },
    { "sliding_popups", "bool", 0, 0, 0 },
    { "slide_in_duration", "int", "<min>50</min><max>1000</max>", 0, 0 },
    { "slide_out_duration", "int", "<min>50</min><max>1000</max>", 0, 0 },
};

static Bool kdecompatOptionsSetScreenOption (CompPlugin *plugin, CompScreen *s, const char *name, CompOptionValue *value)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    CompOption *o;
    int        index;

    o = compFindOption (os->opt, KdecompatScreenOptionNum, name, &index);

    if (!o)
        return FALSE;

    switch (index)
    {
     case KdecompatScreenOptionPlasmaThumbnails:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[KdecompatScreenOptionPlasmaThumbnails])
                (*os->notify[KdecompatScreenOptionPlasmaThumbnails]) (s, o, KdecompatScreenOptionPlasmaThumbnails);
            return TRUE;
        }
        break;
     case KdecompatScreenOptionPresentWindows:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[KdecompatScreenOptionPresentWindows])
                (*os->notify[KdecompatScreenOptionPresentWindows]) (s, o, KdecompatScreenOptionPresentWindows);
            return TRUE;
        }
        break;
     case KdecompatScreenOptionSlidingPopups:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[KdecompatScreenOptionSlidingPopups])
                (*os->notify[KdecompatScreenOptionSlidingPopups]) (s, o, KdecompatScreenOptionSlidingPopups);
            return TRUE;
        }
        break;
     case KdecompatScreenOptionSlideInDuration:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[KdecompatScreenOptionSlideInDuration])
                (*os->notify[KdecompatScreenOptionSlideInDuration]) (s, o, KdecompatScreenOptionSlideInDuration);
            return TRUE;
        }
        break;
     case KdecompatScreenOptionSlideOutDuration:
        if (compSetScreenOption (s, o, value))
        {
            if (os->notify[KdecompatScreenOptionSlideOutDuration])
                (*os->notify[KdecompatScreenOptionSlideOutDuration]) (s, o, KdecompatScreenOptionSlideOutDuration);
            return TRUE;
        }
        break;
    default:
        break;
    }
    return FALSE;
}

static CompOption * kdecompatOptionsGetScreenOptions (CompPlugin *plugin, CompScreen *s, int *count)
{
    KDECOMPAT_OPTIONS_SCREEN(s);
    if (!os)
    {
        *count = 0;
        return NULL;
    }
    *count = KdecompatScreenOptionNum;
    return os->opt;
}

static Bool kdecompatOptionsInitScreen (CompPlugin *p, CompScreen *s)
{
    KdecompatOptionsScreen *os;
    
    KDECOMPAT_OPTIONS_DISPLAY (s->display);

    os = calloc (1, sizeof(KdecompatOptionsScreen));
    if (!os)
        return FALSE;

    s->base.privates[od->screenPrivateIndex].ptr = os;

    if (!compInitScreenOptionsFromMetadata (s, &kdecompatOptionsMetadata, kdecompatOptionsScreenOptionInfo, os->opt, KdecompatScreenOptionNum))
    {
        free (os);
        return FALSE;
    }

    return TRUE;
}

static void kdecompatOptionsFiniScreen (CompPlugin *p, CompScreen *s)
{
    KDECOMPAT_OPTIONS_SCREEN (s);
    KDECOMPAT_OPTIONS_DISPLAY (s->display);


    compFiniScreenOptions (s, os->opt, KdecompatScreenOptionNum);

    free (os);
    s->base.privates[od->screenPrivateIndex].ptr = NULL;
}

static Bool kdecompatOptionsInitDisplay (CompPlugin *p, CompDisplay *d)
{
    KdecompatOptionsDisplay *od;
   
    
    od = calloc (1, sizeof(KdecompatOptionsDisplay));
    if (!od)
        return FALSE;

    od->screenPrivateIndex = allocateScreenPrivateIndex(d);
    if (od->screenPrivateIndex < 0)
    {
        free(od);
        return FALSE;
    }

    d->base.privates[KdecompatOptionsDisplayPrivateIndex].ptr = od;

    
    return TRUE;
}

static void kdecompatOptionsFiniDisplay (CompPlugin *p, CompDisplay *d)
{
    KDECOMPAT_OPTIONS_DISPLAY (d);

    freeScreenPrivateIndex(d, od->screenPrivateIndex);
    free (od);
    d->base.privates[KdecompatOptionsDisplayPrivateIndex].ptr = NULL;
}

static Bool kdecompatOptionsInit (CompPlugin *p)
{
    KdecompatOptionsDisplayPrivateIndex = allocateDisplayPrivateIndex();
    if (KdecompatOptionsDisplayPrivateIndex < 0)
        return FALSE;

    if (!compInitPluginMetadataFromInfo (&kdecompatOptionsMetadata, "kdecompat",0, 0, kdecompatOptionsScreenOptionInfo, KdecompatScreenOptionNum))
        return FALSE;

    compAddMetadataFromFile (&kdecompatOptionsMetadata, "kdecompat");
    if (kdecompatPluginVTable && kdecompatPluginVTable->init)
        return kdecompatPluginVTable->init (p);
    return TRUE;
}

static void kdecompatOptionsFini (CompPlugin *p)
{
    if (kdecompatPluginVTable && kdecompatPluginVTable->fini)
        kdecompatPluginVTable->fini (p);

    if (KdecompatOptionsDisplayPrivateIndex >= 0)
        freeDisplayPrivateIndex (KdecompatOptionsDisplayPrivateIndex);

    compFiniMetadata (&kdecompatOptionsMetadata);
}

static CompBool kdecompatOptionsInitObject (CompPlugin *p, CompObject *o)
{
    static InitPluginObjectProc dispTab[] = {
        (InitPluginObjectProc) 0,
        (InitPluginObjectProc) kdecompatOptionsInitDisplay,
        (InitPluginObjectProc) kdecompatOptionsInitScreen
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), TRUE, (p, o));
}

static void kdecompatOptionsFiniObject (CompPlugin *p, CompObject *o)
{
    static FiniPluginObjectProc dispTab[] = {
        (FiniPluginObjectProc) 0,
        (FiniPluginObjectProc) kdecompatOptionsFiniDisplay,
        (FiniPluginObjectProc) kdecompatOptionsFiniScreen
    };

    DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), (p, o));
}

static CompBool kdecompatOptionsInitObjectWrapper (CompPlugin *p, CompObject *o)
{
    CompBool rv = TRUE;
    rv = kdecompatOptionsInitObject (p, o);
    if (kdecompatPluginVTable->initObject)
        rv &= kdecompatPluginVTable->initObject (p, o);
    return rv;
}

static void kdecompatOptionsFiniObjectWrapper (CompPlugin *p, CompObject *o)
{
    if (kdecompatPluginVTable->finiObject)
        kdecompatPluginVTable->finiObject (p, o);
    kdecompatOptionsFiniObject (p, o);
}

static CompOption * kdecompatOptionsGetObjectOptions (CompPlugin *p, CompObject *o, int *count)
{
    static GetPluginObjectOptionsProc dispTab[] = {
        (GetPluginObjectOptionsProc) 0,
            (GetPluginObjectOptionsProc) 0,
        (GetPluginObjectOptionsProc) kdecompatOptionsGetScreenOptions
    };

    *count = 0;
    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab),
		     NULL, (p, o, count));
}

static CompBool kdecompatOptionsSetObjectOption (CompPlugin *p, CompObject *o, const char *name, CompOptionValue *value)
{
    static SetPluginObjectOptionProc dispTab[] = {
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) 0,
        (SetPluginObjectOptionProc) kdecompatOptionsSetScreenOption
    };

    RETURN_DISPATCH (o, dispTab, ARRAY_SIZE (dispTab), FALSE,
		     (p, o, name, value));
}

static CompMetadata *
kdecompatOptionsGetMetadata (CompPlugin *plugin)
{
    return &kdecompatOptionsMetadata;
}

CompPluginVTable *getCompPluginInfo20070830 (void)
{
    if (!kdecompatPluginVTable)
    {
        kdecompatPluginVTable = getCompPluginInfo ();
        memcpy(&kdecompatOptionsVTable, kdecompatPluginVTable, sizeof(CompPluginVTable));
        kdecompatOptionsVTable.getMetadata = kdecompatOptionsGetMetadata;
        kdecompatOptionsVTable.init = kdecompatOptionsInit;
        kdecompatOptionsVTable.fini = kdecompatOptionsFini;
        kdecompatOptionsVTable.initObject = kdecompatOptionsInitObjectWrapper;
        kdecompatOptionsVTable.finiObject = kdecompatOptionsFiniObjectWrapper;
        kdecompatOptionsVTable.getObjectOptions = kdecompatOptionsGetObjectOptions;
	kdecompatOptionsVTable.setObjectOption = kdecompatOptionsSetObjectOption;
	
    }
    return &kdecompatOptionsVTable;
}

